.MODULE/BOOT=0/ABS=0    dit_fft_main;

{ main program for 32-bit data, 16-bit twiddle factor radix-2, dit fft }
{ executes in 12200 cycles or 732us at 60ns DSP clock                  }
{ 128 point transform executes inside the ADSP-2101                    }

.CONST                  N=128, N_div_2=64;    {Const. for # of points}
.VAR/PM/RAM/CIRC        twid_real [N_div_2];
.VAR/PM/RAM/CIRC        twid_imag [N_div_2];
.VAR/DM/RAM/CIRC        inputreal [N], inputimag [N];
.VAR/DM/RAM             groups, bflys_per_group, node_space, blk_exponent;

.VAR/DM/RAM/CIRC/ABS=0x3800     real_lsw [N], real_msw [N],
                                imag_lsw [N], imag_msw [N];

.INIT   twid_real: <twid_rea.dat>;
.INIT   twid_imag: <twid_ima.dat>;
.INIT   inputreal: <input.dat>;
.INIT   inputimag: <zero.dat>;
.INIT   imag_lsw: <zero.dat>;       { zero for demo }
.INIT   imag_msw: <zero.dat>;       { zero for demo }
.INIT   groups: N_div_2;
.INIT   bflys_per_group: 1;
.INIT   node_space: 1;
.INIT   blk_exponent: 0;

.GLOBAL twid_real, twid_imag;
.GLOBAL real_lsw, real_msw, imag_lsw, imag_msw;
.GLOBAL inputreal, inputimag;
.GLOBAL groups, bflys_per_group, node_space, blk_exponent;

.EXTERNAL       scramble, fft_strt;

         JUMP start; RTI; NOP; NOP;
         RTI; NOP; NOP; NOP;
         RTI; NOP; NOP; NOP;
         RTI; NOP; NOP; NOP;
         RTI; NOP; NOP; NOP;
         RTI; NOP; NOP; NOP;
         RTI; NOP; NOP; NOP;


start:   SI=0;
         DM(0x3FFE)=SI;          { dm wait states 0 }
         CALL scramble;          {subroutine calls}
         CALL fft_strt;
         NOP;                    {halt program}

.ENDMOD;






 