.MODULE/BOOT=0 dit_scramble;

{       Calling Parameters
                Sequentially ordered input data in inputreal, inputimag

        Return Values
                Scrambled real input data in real_lsw
                sign-extended into real_msw
                Scrambled imaginary input data in imag_lsw
                sign-extended into imag_msw

        Altered Registers
                I0,I1,I2,I3,I4,M0,M4,AY1

        Altered Memory
                real_lsw, real_msw, imag_lsw, imag_msw

        Computation Time:
                (6 * N) + 19 = 787 cycles if N = 128
}

.CONST        N=128, mod_value=H#0080;        {Initialize constants}

              {to calculate correct mod_value, divide 16384 by N}

              {have to calculate bit-reversed addresses by hand}

.CONST        real_lsw_rev = 0x0007, real_msw_rev = 0x0047;
.CONST        imag_lsw_rev = 0x0027, imag_msw_rev = 0x0067;

.EXTERNAL     inputreal, inputimag, real_lsw, real_msw, imag_lsw, imag_msw;

              {warning: ^inplacereal must = H#0000 in this case!}

.ENTRY   scramble;

scramble:I4=^inputreal;      {I4,I5-->sequentially ordered data}
         I5=^inputimag;
         I0=real_lsw_rev;    {I0,I1,I2,I3-->scrambled data}
         I1=real_msw_rev;
         I2=imag_lsw_rev;
         I3=imag_msw_rev;
         M4=1;
         M0=mod_value;       {M0=modifier for reversing N bits}
         L4=0; L5=0;
         L0=0; L1=0; L2=0; L3=0;
         CNTR = N;
         ENA BIT_REV;     {Enable bit-reversed outputs on DAG1}
         DO brev UNTIL CE;
                  MR1=DM(I4,M4); {Read sequentially ordered 16-bit real data}
                  DM(I0,M0)=MR1; {Write to bit_rev adr of real_lsw}
                  DM(I1,M0)=MR2; {Write sign-ext to bit_rev adr of real_msw }
                  MR1=DM(I5,M4); {Read sequentially ordered 16-bit imag data}
                  DM(I2,M0)=MR1; {Write to bit_rev adr of imag_lsw}
brev:             DM(I3,M0)=MR2; {Write sign-ext to bit_rev adr of imag_msw }
         DIS BIT_REV;     {Disable bit-reverse}
         RTS;      {Return to calling program}
.ENDMOD;