/****************************************************************/
/*      Twiddle generation program rounded to 16 bits           */
/*                                                              */
/*      This program generates twiddle factors for FFT          */
/*      programs on the ADSP 2100.  Sixteen bit resolution.     */
/****************************************************************/

#include <stdio.h>
#include <math.h>
     
main()
{
  FILE *fi, *fj, *fk;

  double wt, k, wn_real, man, wn_unreal, t_val, frac;
  int i, n, m, rnd_val;
  unsigned long int_val;
  unsigned long pm_val;

  printf("Analog Devices Twiddle Generator for FFT's\t Version 1.01\n");
  printf("Some runtime modules are copyright (C) Microsoft Corp.\n");

  printf("\nEnter N for an N-pt FFT\n");
  scanf("%d",&n);

  printf("\nEnter twiddle factor format option\n");
  printf("1. Real and Imag twiddles in seperate files (as in RAD 2)\n");
  printf("2. Real and Imag twiddles interlaced in same file (as in RAD 4)\n");
  scanf("%d",&m);

  if (m==1) 
    {
      fi = fopen("twid_real.dat","w");
      fj = fopen("twid_imag.dat","w");
 
      pm_val = 8388352;                  /*first twiddle real = 1 */
      fprintf(fi,"%06lX\n",pm_val);     
      pm_val = 0;
      fprintf(fj,"%06lX\n",pm_val);
      i = 1;
      k = 2 * 3.1415926 / n;
      n = n / 2;
      while(i < n)
        {
        wt = i * k;
        wn_real = cos(wt);
        wn_unreal = (-1)*sin(wt);
        t_val = wn_real * 32767.0 ;
        frac = modf(t_val,&man);
        if (frac < 0) 
          {
            rnd_val = (-1);
            if (frac > -0.5) rnd_val = 0;
          }
        else 
          {
            rnd_val = 1;
            if (frac < 0.5) rnd_val = 0;
          }
        int_val = man + rnd_val;
        int_val = int_val & 0XFFFF;
        pm_val = int_val * 256 ;
        fprintf(fi,"%06lX\n",pm_val);

        t_val = wn_unreal * 32767.0;
        frac = modf(t_val,&man);
        if (frac < 0) 
          {
            rnd_val = (-1);
            if (frac > -0.5) rnd_val = 0;
          }
        else 
          {
            rnd_val = 1;
            if (frac < 0.5) rnd_val = 0;
          }
        int_val = man + rnd_val;
        int_val = int_val & 0XFFFF;
        pm_val = int_val * 256;
        fprintf(fj,"%06lX\n",pm_val);
        i = i + 1;
      }

    fclose(fi);
    fclose(fj);
    printf("\nReal Twiddles in file twid_real.dat\n");
    printf("Imaginary Twiddles in file twid_imag.dat\n");
  }

else if (m==2) 
  {

    fk = fopen("twids.dat","w");

    pm_val = 8388352;                  /*first twiddle real = 1 */
    fprintf(fk,"%06lX\n",pm_val);     
    pm_val = 0;
    fprintf(fk,"%06lX\n",pm_val);
    i = 1;
    k = 2 * 3.1415926 / n;
    n = n / 2;
    while(i < n)
      {
        wt = i * k;
        wn_real = cos(wt);
        wn_unreal = (-1)*sin(wt);
        t_val = wn_real * 32767.0;
        frac = modf(t_val,&man);
        if (frac < 0) 
          {
            rnd_val = -1;
            if (frac > -0.5) rnd_val = 0;
          }
        else 
          {
            rnd_val = 1;
            if (frac < 0.5) rnd_val = 0;
          }
        int_val = man + rnd_val;
        int_val = int_val & 0XFFFF;
        pm_val = int_val * 256;
        fprintf(fk,"%06lX\n",pm_val);

        t_val = wn_unreal * 32767.0 ;
        frac = modf(t_val,&man);
        if (frac < 0) 
          {
          rnd_val = -1;
          if (frac > -0.5) rnd_val = 0;
          }
        else 
          {
          rnd_val = 1;
          if (frac < 0.5) rnd_val = 0;
          }
        int_val = man + rnd_val;
        int_val = int_val & 0XFFFF;
        pm_val = int_val * 256;
        fprintf(fk,"%06lX\n",pm_val);
        i = i + 1;
      }
    fclose(fk);
    printf("\nTwiddles in file twids.dat\n");
  }
  else printf("ERROR --- invalid option specified\n");
}
